org 100h
bits 16

%xdefine _x86_Portable__PLATFORMBITS_ 32

%include "00000000__x86_Portable.asm"

%macro SetVGAMode 1
    ;mov byte[cbitmode],0

    mov ax,0013h
    int 10h

    mov dx,03d4h
    mov ax,0011h
    out dx,ax
    inc edx
    in al,dx
    and al,07fh
    mov ah,al
    mov al,11h
    dec edx
    out dx,ax

    xor ecx,ecx
    jmp %%start

%%loop:
    add ecx,4

%%start:
    mov eax,[%1+ecx]
    or eax,eax
    jz %%end

    cmp ax,03c0h
    je %%3c0
    cmp ax,03c2h
    je %%3c2
    cmp ax,03c3h
    je %%3c2
    jmp %%default

%%3c0:
    mov dx,03dah
    in al,dx
    mov dl,0c0h
    shr eax,16
    or al,20h
    out dx,al
    shr eax,8
    out dx,al
    jmp %%loop

%%3c2:
    mov dx,ax
    rol eax,8
    out dx,al
    jmp %%loop

%%default:
    mov dx,ax
    shr eax,16
    out dx,ax
    jmp %%loop

%%end:
%endmacro




    mov bx,0A000h
    mov bx,0B000h  ;for mode 4
    ;call findselec
    mov [selcA000],ax
    mov [selcA000],bx





;Inputs:
;---------------
;BX: Value bits to select mono or color port:
;                   --
;          0000000001000000b -- color (produce 0x3DA)
;          0000000000100000b -- mono  (produce 0x3BA)
 ;                   --
;
;ESI == Base address of the register set
;;
 mov ax,4h
 int 10h
 mov bx,0000000001000000b
 mov esi,CGA_320x240x256_ModeX_Gen__Regs
 mov esi,VGA_640x480x16Gen__Regs
 mov esi,CGA_320x200x4Gen__MiscOutputReg
 call VGA_Config_All_Regs



;    SetVGAMode Mode320x256
;mov ax,1300h
;int 10h








;mov ebx,-1
;mov ax,0xA000
;mov ds,ax
;mov dword[0],ebx





call cscopymodex
;call makepal



;jmp $
mov ah,0
int 16h


mov ax,3
int 10h



mov ax,4C00h
int 21h


selcA000 dd 0xA000

cscopymodex:
    ; select all planes
    mov edx,03C4h
    mov eax,0F02h
    out dx,ax
    push es
    mov ax,[selcA000]
    mov es,ax
    xor edi,edi
    mov ecx,65536/4
    xor eax,eax
    mov eax,0x56ABCDEF
    rep stosd
    pop es
    ret


; Find Selector - DOS only
findselec:
    mov ax, 2
    int 31h
    jnc .proceed
;    mov edx, .noselector
;    call PrintStr
;    jmp DosExit
.proceed:
    ret


Mode320x256:
    dw 03c2h,0e300h,03d4h,05f00h,03d4h,04f01h,03d4h,05002h,03d4h,08203h
    dw 03d4h,05404h,03d4h,08005h,03d4h,02306h,03d4h,0b207h,03d4h,00008h
    dw 03d4h,06109h,03d4h,00a10h,03d4h,0ac11h,03d4h,0ff12h,03d4h,02813h
    dw 03d4h,00014h,03d4h,00715h,03d4h,01a16h,03d4h,0e317h,03c4h,00101h
    dw 03c4h,00604h,03ceh,04005h,03ceh,00506h,03c0h,04110h,03c0h,00013h
    dd 0

    
    
    
    
    
    
%include "VGA/main.asm"
    
    
    
    
    
    
    
    
    
    
